/////////////////////////////////////////////////
// CCircles.cpp
/////////////////////////////////////////////////

#include "stdafx.h"
#include "CCircles.h"

IMPLEMENT_SERIAL(CCircles, CObject, 1)

CCircles::CCircles()
{
}

void CCircles::AddCircle(CPoint point, COLORREF color, int diameter)
{
	CircleStruct* circle = new CircleStruct;
	circle->point = point;
	circle->color = color;
	circle->diameter = diameter;
	m_circleArray.Add(circle);
}

int CCircles::GetCircleCount()
{
    return m_circleArray.GetSize();
}

void CCircles::GetCircle(int circleNum, CircleStruct* circle)
{
    CircleStruct* circleStruct =
        (CircleStruct*)m_circleArray.GetAt(circleNum);
	circle->point = circleStruct->point;
	circle->color = circleStruct->color;
	circle->diameter = circleStruct->diameter;
}

void CCircles::DeleteAllCircles()
{
	int size = GetCircleCount();
	for (int x=0; x<size; ++x)
	{
		CircleStruct* circle =
			(CircleStruct*)m_circleArray.GetAt(x);
		delete circle;
	}
	m_circleArray.RemoveAll();
}

void CCircles::Serialize(CArchive& ar)
{
	CObject::Serialize(ar);

	if (ar.IsStoring())
	{
		CircleStruct circle;
    	int size = GetCircleCount();
		ar << size;

	    for (int x=0; x<size; ++x)
		{
		    GetCircle(x, &circle);
		    ar << circle.point;
			ar << circle.color;
			ar << circle.diameter;
		}
	}
	else
	{
		int size;
    	ar >> size;

	    for (int x=0; x<size; ++x)
		{
			CPoint point;
			COLORREF color;
			int diameter;
			ar >> point;
			ar >> color;
			ar >> diameter;
			AddCircle(point, color, diameter);
		}

	}
}

