// stringView.cpp : implementation of the CStringView class
//

#include "stdafx.h"
#include "string.h"

#include "stringDoc.h"
#include "stringView.h"
#include "AddStringDlg.h"
#include "ChangeHeaderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStringView

IMPLEMENT_DYNCREATE(CStringView, CView)

BEGIN_MESSAGE_MAP(CStringView, CView)
	//{{AFX_MSG_MAP(CStringView)
	ON_COMMAND(ID_EDIT_ADDSTRING, OnEditAddstring)
	ON_COMMAND(ID_EDIT_CHANGEHEADER, OnEditChangeheader)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStringView construction/destruction

CStringView::CStringView()
{
	// TODO: add construction code here

}

CStringView::~CStringView()
{
}

BOOL CStringView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CStringView drawing

void CStringView::OnDraw(CDC* pDC)
{
	CStringDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

	int row = 20;
	int size = pDoc->m_strArray.GetSize();

	for (int x=0; x<size; ++x)
	{
		CString str = pDoc->m_strArray.GetAt(x);
		pDC->TextOut(20, row, str);
		if (x==0)
			row += 40;
		else
			row += 20;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CStringView diagnostics

#ifdef _DEBUG
void CStringView::AssertValid() const
{
	CView::AssertValid();
}

void CStringView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CStringDoc* CStringView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStringDoc)));
	return (CStringDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CStringView message handlers

void CStringView::OnEditAddstring() 
{
	// TODO: Add your command handler code here

	CStringDoc* pDoc = GetDocument();
	CAddStringDlg dialog;
	int result = dialog.DoModal();

	if (result == IDOK)
	{
		CString str = dialog.m_string;
		pDoc->m_strArray.Add(str);
		Invalidate();
	}
}

void CStringView::OnEditChangeheader() 
{
	// TODO: Add your command handler code here
	
	CStringDoc* pDoc = GetDocument();
	CChangeHeaderDlg dialog;
	int result = dialog.DoModal();

	if (result == IDOK)
	{
		CString str = dialog.m_header;
		pDoc->m_strArray.SetAt(0, str);
		Invalidate();
	}
}
